TektonPipeline [operator.tekton.dev/v1alpha1]

Description
TektonPipeline is the Schema for the tektonpipelines API
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

TektonPipelineSpec defines the desired state of TektonPipeline

statusobject

TektonPipelineStatus defines the observed state of TektonPipeline

.spec

Description
TektonPipelineSpec defines the desired state of TektonPipeline
Type
object
Required
options
PropertyTypeDescription
await-sidecar-readinessboolean
bundles-resolver-configobject
cluster-resolver-configobject
configobject

Config holds the configuration for resources created by TektonPipeline

coschedulestring
default-affinity-assistant-pod-templatestring
default-cloud-events-sinkstring
default-forbidden-envstring
default-managed-by-label-valuestring
default-max-matrix-combinations-countstring
default-pod-templatestring
default-resolver-typestring
default-service-accountstring
default-task-run-workspace-bindingstring
default-timeout-minutesinteger
disable-affinity-assistantboolean
disable-creds-initboolean
disable-inline-specstring
embedded-statusstring
enable-api-fieldsstring
enable-bundles-resolverboolean
enable-cel-in-whenexpressionboolean
enable-cluster-resolverboolean
enable-custom-tasksboolean
enable-git-resolverboolean
enable-hub-resolverboolean
enable-param-enumboolean
enable-provenance-in-statusboolean
enable-step-actionsboolean
enable-tekton-oci-bundlesboolean

not in use, see: https://github.com/tektoncd/pipeline/pull/7789 this field is removed from pipeline component keeping here to maintain the API compatibility

enforce-nonfalsifiabilitystring
git-resolver-configobject
hub-resolver-configobject
keep-pod-on-cancelboolean
max-result-sizeinteger
metrics.count.enable-reasonboolean
metrics.pipelinerun.duration-typestring
metrics.pipelinerun.levelstring
metrics.taskrun.duration-typestring
metrics.taskrun.levelstring
optionsobject

options holds additions fields and these fields will be updated on the manifests

paramsarray

The params to customize different components of Pipelines

performanceobject

PerformanceProperties defines the fields which are configurable to tune the performance of component controller

require-git-ssh-secret-known-hostsboolean
results-fromstring
running-in-environment-with-injected-sidecarsboolean
scope-when-expressions-to-taskboolean

ScopeWhenExpressionsToTask is deprecated and never used.

send-cloudevents-for-runsboolean
set-security-contextboolean
targetNamespacestring

TargetNamespace is where resources will be installed

trusted-resources-verification-no-match-policystring
verification-modestring

.spec.bundles-resolver-config

Type
object

.spec.cluster-resolver-config

Type
object

.spec.config

Description
Config holds the configuration for resources created by TektonPipeline
Type
object
PropertyTypeDescription
nodeSelectorobject
priorityClassNamestring

PriorityClassName holds the priority class to be set to pod template

tolerationsarray

.spec.config.nodeSelector

Type
object

.spec.config.tolerations

Type
array

.spec.config.tolerations[]

Description
The pod this Toleration is attached to tolerates any taint that matches the triple <key,value,effect> using the matching operator <operator>.
Type
object
PropertyTypeDescription
effectstring

Effect indicates the taint effect to match. Empty means match all taint effects. When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute.

keystring

Key is the taint key that the toleration applies to. Empty means match all taint keys. If the key is empty, operator must be Exists; this combination means to match all values and all keys.

operatorstring

Operator represents a key's relationship to the value. Valid operators are Exists and Equal. Defaults to Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.

tolerationSecondsinteger

TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint. By default, it is not set, which means tolerate the taint forever (do not evict). Zero and negative values will be treated as 0 (evict immediately) by the system.

valuestring

Value is the taint value the toleration matches to. If the operator is Exists, the value should be empty, otherwise just a regular string.

.spec.git-resolver-config

Type
object

.spec.hub-resolver-config

Type
object

.spec.options

Description
options holds additions fields and these fields will be updated on the manifests
Type
object
PropertyTypeDescription
configMapsobject
deploymentsobject
disabledboolean
horizontalPodAutoscalersobject
statefulSetsobject
webhookConfigurationOptionsobject

.spec.options.configMaps

Type
object

.spec.options.deployments

Type
object

.spec.options.horizontalPodAutoscalers

Type
object

.spec.options.statefulSets

Type
object

.spec.options.webhookConfigurationOptions

Type
object

.spec.params

Description
The params to customize different components of Pipelines
Type
array

.spec.params[]

Description
Param declares an string value to use for the parameter called name.
Type
object
PropertyTypeDescription
namestring
valuestring

.spec.performance

Description
PerformanceProperties defines the fields which are configurable to tune the performance of component controller
Type
object
Required
disable-ha
PropertyTypeDescription
bucketsinteger
disable-haboolean

if it is true, disables the HA feature

kube-api-burstinteger
kube-api-qpsnumber

queries per second (QPS) and burst to the master from rest API client actually the number multiplied by 2 https://github.com/pierretasci/pipeline/blob/05d67e427c722a2a57e58328d7097e21429b7524/cmd/controller/main.go#L85-L87 defaults: https://github.com/tektoncd/pipeline/blob/34618964300620dca44d10a595e4af84e9903a55/vendor/k8s.io/client-go/rest/config.go#L45-L46

replicasinteger
statefulset-ordinalsboolean

if is true, enable StatefulsetOrdinals mode

threads-per-controllerinteger

The number of workers to use when processing the component controller's work queue

.status

Description
TektonPipelineStatus defines the observed state of TektonPipeline
Type
object
PropertyTypeDescription
annotationsobject

Annotations is additional Status fields for the Resource to save some additional State as well as convey more information to the user. This is roughly akin to Annotations on any k8s resource, just the reconciler conveying richer information outwards.

conditionsarray

Conditions the latest available observations of a resource's current state.

extTektonInstallerSetsobject

The installer sets created for extension components

observedGenerationinteger

ObservedGeneration is the 'Generation' of the Service that was last processed by the controller.

tektonInstallerSetstring

The current installer set name for TektonPipeline

versionstring

The version of the installed release

.status.annotations

Description
Annotations is additional Status fields for the Resource to save some additional State as well as convey more information to the user. This is roughly akin to Annotations on any k8s resource, just the reconciler conveying richer information outwards.
Type
object

.status.conditions

Description
Conditions the latest available observations of a resource's current state.
Type
array

.status.conditions[]

Description
Condition defines a readiness condition for a Knative resource. See: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#typical-status-properties
Type
object
Required
statustype
PropertyTypeDescription
lastTransitionTimestring

LastTransitionTime is the last time the condition transitioned from one status to another. We use VolatileTime in place of metav1.Time to exclude this from creating equality.Semantic differences (all other things held constant).

messagestring

A human readable message indicating details about the transition.

reasonstring

The reason for the condition's last transition.

severitystring

Severity with which to treat failures of this type of condition. When this is not specified, it defaults to Error.

statusstring

Status of the condition, one of True, False, Unknown.

typestring

Type of condition.

.status.extTektonInstallerSets

Description
The installer sets created for extension components
Type
object

API Endpoints

The following API endpoints are available:

  • /apis/operator.tekton.dev/v1alpha1/namespaces/{namespace}/tektonpipelines
    • DELETE: delete collection of TektonPipeline
    • GET: list objects of kind TektonPipeline
    • POST: create a new TektonPipeline
  • /apis/operator.tekton.dev/v1alpha1/namespaces/{namespace}/tektonpipelines/{name}
    • DELETE: delete the specified TektonPipeline
    • GET: read the specified TektonPipeline
    • PATCH: partially update the specified TektonPipeline
    • PUT: replace the specified TektonPipeline
  • /apis/operator.tekton.dev/v1alpha1/namespaces/{namespace}/tektonpipelines/{name}/status
    • GET: read status of the specified TektonPipeline
    • PATCH: partially update status of the specified TektonPipeline
    • PUT: replace status of the specified TektonPipeline

/apis/operator.tekton.dev/v1alpha1/namespaces/{namespace}/tektonpipelines

HTTP method
DELETE
Description
delete collection of TektonPipeline
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind TektonPipeline
HTTP responses
HTTP codeResponse body
200 - OKTektonPipelineList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new TektonPipeline
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyTektonPipeline schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKTektonPipeline schema
201 - CreatedTektonPipeline schema
202 - AcceptedTektonPipeline schema
401 - UnauthorizedEmpty

/apis/operator.tekton.dev/v1alpha1/namespaces/{namespace}/tektonpipelines/{name}

HTTP method
DELETE
Description
delete the specified TektonPipeline
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified TektonPipeline
HTTP responses
HTTP codeResponse body
200 - OKTektonPipeline schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified TektonPipeline
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKTektonPipeline schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified TektonPipeline
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyTektonPipeline schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKTektonPipeline schema
201 - CreatedTektonPipeline schema
401 - UnauthorizedEmpty

/apis/operator.tekton.dev/v1alpha1/namespaces/{namespace}/tektonpipelines/{name}/status

HTTP method
GET
Description
read status of the specified TektonPipeline
HTTP responses
HTTP codeResponse body
200 - OKTektonPipeline schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified TektonPipeline
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKTektonPipeline schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified TektonPipeline
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyTektonPipeline schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKTektonPipeline schema
201 - CreatedTektonPipeline schema
401 - UnauthorizedEmpty